#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
long long a[100050];
long long tree[400050];
void build(int v, int b, int e)
{
    if(b==e)
    {
        tree[v]=a[b];
        return;
    }
    int mid=(b+e)/2;
    build(2*v, b, mid);
    build(2*v+1, mid+1, e);
    tree[v]=tree[2*v]+tree[2*v+1];
}
void update(int v, int b, int e,int k, int d)
{
    if(k<b||k>e)return;
    if(b==e&&b==k)
    {
        tree[v]-=d;
        return;
    }
	int mid=(b+e)/2;
    update(2*v, b, mid,k,d);
    update(2*v+1, mid+1, e,k,d);
    tree[v]=tree[2*v]+tree[2*v+1];
}
int query(int v, int b, int e, int l, int r)
{
	if(r<b||l>e)return 0;
	if(l<=b&&r>=e)return tree[v];
	int mid=(b+e)/2;
	return query(2*v,b,mid,l,r)+query(2*v+1,mid+1,e,l,r);
}
struct ind
{
    long long br,i;
} t[100050];
struct inter
{
    long long l,r;
} in[1000050];
bool cmp(ind p, ind q)
{
    return p.br>q.br;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long n,m;
    long long k;
    cin>>n>>m>>k;
    for(long long i=0; i<n; i++)
    {
        cin>>a[i];
    }
    build(1,0,n-1);
    for(long long i=0; i<n; i++)
    {
        t[i].i=i;
    }
    for(long long i=0; i<m; i++)
    {
        cin>>in[i].l>>in[i].r;
        for(long long j=in[i].l-1; j<in[i].r; j++)
        {
            t[j].br++;
        }
    }
    sort(t,t+n,cmp);
    //for(int i=0;i<2*n;i++)cout<<tree[i]<<" ";
    for(long long i=0; i<n; i++)
    {
        if(a[t[i].i]<=k)
        {
            update(1,0,n-1,t[i].i,a[t[i].i]);
            k-=a[t[i].i];
        }
        else
        {
            update(1,0,n-1,t[i].i,k);
            break;
        }
    }
    long long sum=0;
	for(int i=0;i<m;i++)
	{
		sum+=query(1,0,n-1,in[i].l-1,in[i].r-1);
	}
    cout<<sum<<endl;
}
