#include <iostream>
#include <bitset>
using namespace std;
const int maxn = 2e5+10;
bitset < maxn > bs;
int n;
char bit;

int counting[2];

int check(int k, bool start) {
    counting[0] = counting[1] = 0;
    bool which = start;
    int length = 0;

    //cout << "   check: " << k << ' ' << start << '\n';

    for (int i = 1 ; i <= n ; ++i) {
        ++counting[bs[i]];
        //cout << "       ++ to " << bs[i] << ' ' << counting[bs[i]] << '\n';
        if (counting[which] == k) {
            ++length;
            counting[0] = counting[1] = 0;
            which = !which;
            //cout << "       flip: " << i << '\n'; 
        }
    }

    return (length < 2 ? 0 : length*k);

}

int calc(int k) {
    return max(check(k, 0), check(k, 1));
}

int ans, ix;
int main () {
    //ios_base :: sync_with_stdio(0);
    //cin.tie(nullptr);
    //cout.tie(nullptr);
    cin >> n;

    for (int i = 1 ; i <= n ; ++i) {
        cin >> bit;
        //cout << "input: " << bit << '\n';
        bs[i] = bit-'0';
    }

    for (int i = 1 ; i <= n ; ++i) {
        int res = calc(i);
        //cout << "i: " << i << ' ' << res << '\n';
        if (ans < res) {
            ans = res;
            ix = i;
        }
    }

    cout << ans << ' ' << ix << '\n';
    return 0;
}
