#include <iostream>
#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")
using namespace std;
const int maxn = 2e5+10, buff_size = 2e4;
bool bs[2];
int n;
char bit;
char buff[buff_size];
int buff_ix = buff_size-1;
int a[maxn], m = 1;
inline void read_char() {
    if (++buff_ix == buff_size) fread(buff, buff_size, 1, stdin), buff_ix = 0;
}
inline void read_int(int &ret) {
    ret = 0;
    for (; buff[buff_ix] < '0' || buff[buff_ix] > '9'; read_char());
    for (;  '0' <= buff[buff_ix] && buff[buff_ix] <= '9'; read_char())
        ret = 10*ret + buff[buff_ix] - '0';
}
inline void read_string(char ret[]) {
    int len = 0;
    for (; buff[buff_ix] < '0' || buff[buff_ix] > '1'; read_char());
    for (; '0' <= buff[buff_ix]  && buff[buff_ix] <= '1'; read_char())
        ret[len++] = buff[buff_ix];
    ret[len] = '\0';
}
int counting[2];
inline int check(int k, bool start) {
    counting[0] = counting[1] = 0;
    bool which = start;
    int length = 0;
    //cout << "   check: " << k << ' ' << start << '\n';
    for (int i = 1 ; i <= m ; ++i) {
        counting[(a[i] > 0)] += abs(a[i]);
        //cout << "       ++ to " << a[i] << ' ' << counting[(a[i] > 0)] << '\n';
        if (counting[which] >= k) {
            ++length;
            counting[0] = counting[1] = 0;
            which = !which;
            //cout << "       flip: " << i << '\n'; 
        }
    }
    return length;
}
inline int calc(int k) {
    return max(check(k, 0), check(k, 1));
}
char inp[maxn];
int ans, ix;
int main () {
    ios_base :: sync_with_stdio(0);
    read_int(n);
    read_string(inp);
    for (int i = 1 ; i <= n ; ++i) {
        //cout << "input: " << bit << '\n';
        bs[i&1] = inp[i-1]-'0';
        if (i == 1 || bs[i&1] == bs[(i+1)&1]) a[m] += (bs[i&1] == 1 ? 1 : -1);
        else a[++m] = (bs[i&1] == 1 ? 1 : -1);
    }

    for (int i = 1 ; i <= n/2 ; ++i) {
        int res = calc(i);
        if (res < 2 || (n/res)*res <= ans) break;
        //cout << "i: " << i << ' ' << res << '\n';
        res *= i;
        if (ans < res) {
            ans = res;
            ix = i;
        }
    }
    cout << ans << ' ' << ix << '\n';
    return 0;
}
