#include <iostream>
#include <algorithm>
#define int __int128
using namespace std;
const int maxn = 1e2 + 10;//,  base;

/*
vector < int > add(const vector < int > &a, const vector < int > &b) {
    vector < int > c;
    int prenos = 0;
}*/

int dp[maxn][maxn];
int ans = 1, left_to_fill;
string s;

void init_dp() {
    for (int i = 0 ; i <= left_to_fill ; ++i) dp[i][0] = 1;
    for (int i = 1 ; i <= left_to_fill ; ++i) {
        for (int j = 1 ; j <= i ; ++j) {
            dp[i][j] = dp[i-1][j-1] + dp[i-1][j];
            //cout << "dp[" << i <<"][" << j << "] = " << dp[i][j] << '\n'; 
        }
    }
}

void convert() {
    while (ans > 0) {
        s += ans%10 + '0';
        ans /= 10;
    }
    reverse(s.begin(), s.end());
}

long long a[maxn], n;

signed main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    
    for (int i = 1 ; i <= n ; ++i) {
        cin >> a[i];
        left_to_fill += a[i];
    }
    
    init_dp();

    for (int i = 1 ; i < n ; ++i) {
        if (a[i] == 0) {
            cout << 0 << '\n';
            return 0;
        }
        //cout << "multiply: " << ans << ' ' << left_to_fill << ' ' << a[i] << ' ' << dp[left_to_fill-1][a[i]-1] << '\n';
        ans *= dp[left_to_fill-1][a[i]-1];
        left_to_fill -= a[i];
    }

    convert();

    cout << s << '\n';

    return 0;
    

}