#include<iostream>
#include<algorithm>
using namespace std;

const int MAXN=10e5+7;
int lazy_uses[4*MAXN];
int tree[4*MAXN];
int p;
long long SUMB;
int p2;
pair<int,int> brPolzvaniqVSum[MAXN];

void build_tree(int l,int r,int ind){
    if(l==r){
        cin>>tree[ind];
        p++;
    }else{
        int m=(l+r)/2;
        build_tree(l,m,2*ind);
        build_tree(m+1,r,2*ind+1);
        tree[ind]=tree[2*ind]+tree[2*ind+1];
    }
}
void find_sum_and_count_uses(int l,int r,int li,int ri,int n){
    if(li<=l and ri>=r){
        lazy_uses[n]++;
        SUMB+=tree[n];
    }else{
        int m=(l+r)/2;
        if(li<=m and li>=l){
            find_sum_and_count_uses(l,m,li,ri,n*2);
        }
        if(ri<=r and ri>m){
            find_sum_and_count_uses(m+1,r,li,ri,n*2+1);
        }

    }
}

void nameri_broi_polzvaniq_na_listo(int l,int r,int ind){
    //cout<<"klon "<<n<<" e"<<lazy_uses[n]<<"
    if(ind>1) lazy_uses[ind]+=lazy_uses[ind/2];
    if(l==r){
        brPolzvaniqVSum[p2].first=lazy_uses[ind];
        brPolzvaniqVSum[p2].second=tree[ind];
        p2++;
    }else{
        int m=(l+r)/2;
        nameri_broi_polzvaniq_na_listo(l,m,2*ind);
        nameri_broi_polzvaniq_na_listo(m+1,r,2*ind+1);
    }
}
bool el(pair<int,int> a, pair<int,int> b){
    if(a.first>b.first){
        return a.first>b.first;
    }else{
        return a.second>b.second;
    }
}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int N,M,K;
    cin>>N>>M>>K;
    int l,r;
    build_tree(1,N,1);
    for(int i=0;i<M;i++){
        cin>>l>>r;
        find_sum_and_count_uses(1,N,l,r,1);
    }
    nameri_broi_polzvaniq_na_listo(1,N,1);
    sort(brPolzvaniqVSum,brPolzvaniqVSum+N,el);
    for(auto t:brPolzvaniqVSum){
        if(K==0) break;
        if(t.second>0 and K>t.second){
            SUMB-=t.second*t.first;
            K-=t.second;
        }else if(t.second>0 and K>0){
            SUMB-=t.first*K;
            break;
        }
    }
    cout<<SUMB<<"\n";
    return 0;
}
