#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

long long n, m, k;
long long a[100006];
int segmtree[500000];

void update(int vr, int le, int ri, int be, int en)
{
    if(en<le || ri<be) return;
    if(be<=le && ri<=en) segmtree[vr]++;
    else
    {
        int mid=(le+ri)/2;
        update(2*vr, le, mid, be, en);
        update(2*vr+1, mid+1, ri, be, en);
    }
}

int query(int vr, int le, int ri, int id)
{
    if(le==ri) return segmtree[vr];
    else
    {
        int mid=(le+ri)/2;
        if(id<=mid) return segmtree[vr]+query(2*vr, le, mid, id);
        return segmtree[vr]+query(2*vr+1, mid+1, ri, id);
    }
}

long long b[1000005];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m>>k;
    for(int i=1; i<=n; i++) cin>>a[i];
    for(int i=0; i<m; i++)
    {
        int le, ri;
        cin>>le>>ri;
        update(1, 0, 100002, le, ri);
    }
    for(int i=1; i<=n; i++)
    {
        int brp=query(1, 0, 100002, i);
        b[brp]+=a[i];
    }
    long long res=0;
    for(int i=m; i>=0; i--)
    {
        if(k>=b[i])
        {
            k-=b[i];
            b[i]=0;
        }
        else
        {
            b[i]-=k;
            k=0;
        }
        res+=b[i]*i;
    }
    cout<<res<<endl;
    return 0;
}


