#include <iostream>
#include <vector>
#include <algorithm>
#define int long long
using namespace std;
const int maxn = 1e5+10, maxm = 1e6+10, buff_size = 2e5;
char buff[buff_size];
int buff_ix = buff_size-1;

void read_char() {
    if (++buff_ix == buff_size) fread(buff, buff_size, 1, stdin), buff_ix = 0;
}

void read_int(int &ret) {
    ret = 0;
    for (; buff[buff_ix] < '0' || buff[buff_ix] > '9'; read_char());
    for (;  '0' <= buff[buff_ix] && buff[buff_ix] <= '9'; read_char())
        ret = 10*ret + buff[buff_ix] - '0';
}

vector < int > v[maxm];

int a[maxn], n, m, k;
int p[maxn], l, r, curr, max_curr;

int solve() {
    int curr_minus = 0, sum = 0;

    for (int i = max_curr ; i > 0 ; --i) {
        for (int j : v[i]) {
            sum += j*i;
            curr_minus += min(k, j)*i;
            k -= min(k, j);
        }
    }

    return sum - curr_minus;

}

signed main () {
    ios_base :: sync_with_stdio(0);
    cout.tie(nullptr);
    read_int(n);
    read_int(m);
    read_int(k);

    for (int i = 1 ; i <= n ; ++i)
        read_int(a[i]);

    for (int i = 1 ; i <= m ; ++i) {
        read_int(l); read_int(r);
        ++p[l]; --p[r+1];
    }

    for (int i = 1 ; i <= n ; ++i) {
        curr += p[i];
        //cout << "i: " << i << ' ' << a[i] << ' ' << curr << '\n';
        v[curr].push_back(a[i]);
        max_curr = max(max_curr, curr);
    }

    for (int i = 1 ; i <= max_curr ; ++i) {
        sort(v[i].begin(), v[i].end(), greater < int > ());
    }

    cout << solve() << '\n';

    return 0;
}
