#include <bits/stdc++.h>
#define endl '\n'

int n, m, l, r;
std::pair<int, long long> a[100001];
int tree[400001];
long long b;
long long k;

void update(int ind, int s, int e, int l, int r) {
    if (l <= s && e <= r) {
        ++ tree[ind];
        return;
    }
    int mid = (s + e) / 2;
    if (l <= mid) {
        update(ind * 2, s, mid, l, r);
    }
    if (r > mid) {
        update(ind * 2 + 1, mid + 1, e, l, r);
    }
}

void collect(int ind, int s, int e, int state) {
    if (s == e) {
        a[s].first = state + tree[ind];
        b += a[s].second * a[s].first;
        return;
    }
    int mid = (s + e) / 2;
    collect(ind * 2, s, mid, state + tree[ind]);
    collect(ind * 2 + 1, mid + 1, e, state + tree[ind]);
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(NULL);
    std::cout.tie(NULL);
    std::cin >> n >> m >> k;
    for (int i = 0; i < n; ++ i) {
        std::cin >> a[i].second;
        a[i].first= 0;
    }
    for (int j = 0; j < m; ++ j) {
        std::cin >> l >> r;
        update(1, 0, n - 1, l - 1, r - 1);
    }
    collect(1, 0, n - 1, 0);
    std::sort(a, a + n);
    int i = n - 1;
    while (k > 0 && i >= 0) {
        b -= std::min(k, a[i].second) * a[i].first;
        k -= std::min(k, a[i].second);
        -- i;
    }
    std::cout << b;
    return 0;
}
