#include <iostream>
using namespace std;
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    long long table[200][200];
    for (int y = 0; y < 101; y++) {
        for (int x = 0; x < 101; x++) {
            if (x == 0 || y == 0) {
                table[x][y] = 1;
            } else {
                table[x][y] = table[x - 1][y] + table[x][y - 1];
            }
        }
    }
    long long n;
    cin >> n;
    pair<long long, long long> arr[100000];
    bool bad = false;
    /// first - elements; second - positions
    for (long long i = 0; i < n; i++) {
        cin >> arr[i].first;
        if (arr[i].first == 0) {
            if (i != n - 1) {
                bad = true;
                continue;
            } else {
                n--;
                continue;
            }
        }
        arr[i].first--;
    }
    if (bad) {
        cout << 0;
        return 0;
    }
    long long sum = 0;
    for (long long i = n - 1; i >= 0; i--) {
        arr[i].second = sum + 1;
        sum += arr[i].first + 1;
    }
    long long ans = 1;
    for (long long i = n - 1; i >= 0; i--) {
        ans *= table[arr[i].first][arr[i].second - 1];
    }
    cout << ans;
    return 0;
}
