#include <iostream>
#include <cmath>
#include <algorithm>
#pragma GCC optimize ("O3")
using namespace std;

const long long maxn = 1e5+1;
long long n, m, k, a[maxn], ps[maxn], sum = 0;
struct p
{
    long long f;
    long long s;
};
p u[maxn];

void update_range(long long l, long long r)
{
    long long i;
    for(i=l; i<=r; ++i)
    {
        ++ u[i].f;
    }
}

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m >> k ;
    long long i, l, r;
    for(i=1; i<=n; ++i)
    {
        cin >> a[i] ;
        ps[i] = ps[i-1] + a[i];
        u[i].s = i;
    }
    for(i=1; i<=m; ++i)
    {
        cin >> l >> r ;
        sum += (ps[r]-ps[l-1]);
        update_range(l , r);
    }
}

bool cmp(p a1, p a2)
{
    if(a1.f == a2.f) return (a1.s < a2.s);
    return (a1.f > a2.f);
}

void solve()
{
    sort(u+1, u+n+1, cmp);
    long long i = 1;
    while(a[u[i].s]<=k && i<=n)
    {
        sum -= (a[u[i].s] * u[i].f);
        k -= a[u[i].s];
        ++ i;
    }
    if(k > 0) sum -= (u[i].f * k);
    if(sum < 0) sum = 0;
    cout << sum << '\n' ;
}

int main()
{
    read();
    solve();
    return 0;
}