#include <iostream>
#define endl '\n'

using namespace std;
const int maxn = 2e5 + 100, maxlg = 20;
const int to_add = 100;
int n, a[maxn], bef[maxn], sw[maxn], lg[maxn], dp[maxn][maxlg], pw[maxlg], calc[maxn], used[maxn];

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

void read()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
    {
        char c;
        cin >> c;
        a[i] = c - '0';
    }
}


int find_max(int x)
{
    int pos = bef[n + 1], ans1 = 0;
    while(true)
    {
        int jump = x - 1, cnt = 0;
        while(jump > 0)
        {
            if (jump % 2 == 1)
                pos = dp[pos][cnt];
            cnt ++;
            jump /= 2;
        }

        if (pos == 0)
            break;
        ans1 ++;
        pos = sw[pos];
    }

    pos = sw[n + 1];
    int ans2 = 0;
    while(true)
    {
        int jump = x - 1, cnt = 0;
        while(jump > 0)
        {
            if (jump % 2 == 1)
                pos = dp[pos][cnt];
            cnt ++;
            jump /= 2;
        }

        if (pos == 0)
            break;
        ans2 ++;
        pos = sw[pos];
    }


    return max(ans1, ans2);
}


void solve()
{
    int ls1 = 0, ls2 = 0;
    for (int i = 1; i <= n + 1; i ++) /// n + 1 is fictional zero
    {
        if (a[i] == 1)
        {
            bef[i] = ls1;
            sw[i] = ls2;
            ls1 = i;
        }
        else
        {
            bef[i] = ls2;
            sw[i] = ls1;
            ls2 = i;
        }
    }

    for (int i = 1; i <= n; i ++)
        dp[i][0] = bef[i], lg[i] = lg[i / 2] + 1;
    for (int i = 0; i <= 20; i ++)
        pw[i] = (1 << i);

    for (int j = 1; j < lg[n]; j ++)
        for (int i = 1; i <= n; i ++)
            dp[i][j] = dp[dp[i][j - 1]][j - 1];


    int idx = 1, ans = 0, f;
    while(true)
    {
        int p;
        if (used[idx] == 1)
            p = calc[idx];
        else
            p = find_max(idx);

        if (p <= 1)
            break;
        if (!used[idx + to_add])
        {
            used[idx + to_add] = 1;
            calc[idx + to_add] = find_max(idx + to_add);
            if (calc[idx + to_add] == p)
            {
                idx = idx + to_add;
                continue;
            }
        }

        if (p * idx > ans)
            ans = p * idx, f = idx;
        idx ++;
    }
    cout << ans << " " << f << endl;

}
int main()
{
    speed();
    read();
    solve();
    return 0;
}
