#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;
const ll maxn = 110;

ll n, a[maxn], s[maxn];
vector < ll > dp[maxn][maxn], ch[maxn * 2][maxn * 2];

vector < ll > add(vector < ll > v1, vector < ll > v2)
{
    while(v1.size() < v2.size())
        v1.push_back(0);
    while(v1.size() > v2.size())
        v2.push_back(0);

    ll p = 0, sz = v1.size();
    vector < ll > r;
    for (ll i = 0; i < sz; i ++)
    {
        ll c = v1[i] + v2[i] + p;
        p = c / 10;
        c = c % 10;
        r.push_back(c);
    }
    if (p != 0)
    r.push_back(p);
    return r;
}

vector < ll > sub(vector < ll > v1, vector < ll > v2)
{
    while(v1.size() < v2.size())
        v1.push_back(0);
    while(v1.size() > v2.size())
        v2.push_back(0);

    ll p = 0, sz = v1.size();
    vector < ll > r;
    for (ll i = 0; i < sz; i ++)
    {
        ll c = v1[i] - v2[i] + p;
        if (c < 0)
            c += 10, p = -1;
        else
            p = 0;
        r.push_back(c);
    }

    return r;
}

vector < ll > mult(vector < ll > v1, vector < ll > v2)
{
    vector < ll > h[10];
    h[0].push_back(0);
    for (ll i = 1; i < 10; i ++)
        h[i] = add(h[i - 1], v1);
    vector < ll > k, r;
    ll sz = v2.size();
    for (ll i = 0; i < sz; i ++)
    {
        ll c = v2[i];
        vector < ll > f = k;
        for (ll p = 0; p < h[c].size(); p ++)
            f.push_back(h[c][p]);
        k.push_back(0);
        r = add(r, f);
    }
    return r;
}
bool cmp(vector < ll > v1, vector < ll > v2)
{
    while(v1.size() < v2.size())
        v1.push_back(0);
    while(v1.size() > v2.size())
        v2.push_back(0);

    ll sz = v1.size();
    for (ll i = sz - 1; i >= 0; i --)
    {
        if (v1[i] > v2[i])
            return true;
        if (v1[i] < v2[i])
            return false;
    }
    return true;
}
vector < ll > div(vector < ll > v, vector < ll > p)
{
    ll sz = v.size();
    vector < ll > d;
    stack < ll > st;
    for (ll i = sz - 1; i >= 0; i --)
    {
        d.insert(d.begin(), v[i]);
        ll cnt = 0;
        while(cmp(d, p))
            d = sub(d, p), cnt ++;
        st.push(cnt);

    }
    vector < ll > r;
    while(!st.empty())
        r.push_back(st.top()), st.pop();
    return r;
}

void print(vector < ll > v)
{
    ll idx = v.size() - 1;
    while(idx >= 0 && v[idx] == 0)
    idx --;
    if (idx < 0)
    {
        cout << 0 << endl;
        return;
    }

    while(idx >= 0)
        cout << v[idx], idx --;
    cout << endl;
}
int main()
{
    cin >> n;
    for (ll i = 1; i <= n; i ++)
        cin >> a[i], s[i] = s[i - 1] + a[i];

    for (ll i = 0; i <= 200; i ++)
        ch[i][0].push_back(1);
    for (ll i = 1; i <= 200; i ++)
        for (ll j = 1; j <= 200; j ++)
        ch[i][j] = add(ch[i - 1][j - 1], ch[i - 1][j]);

    dp[1][1].push_back(1);
    for (ll i = 2; i <= n; i ++)
    for (ll j = i; j <= s[i - 1] + 1; j ++)
    {
        for (ll p = 1; p < j; p ++)
        {
            ll left = s[i - 1] - (j - 1);
            dp[i][j] = add(dp[i][j], mult(dp[i - 1][p], ch[a[i] - 1 + left][left]));
        }
    }

    vector < ll > ans;
    for (ll j = 0; j <= s[n]; j ++)
        ans = add(ans, dp[n][j]);

    print(ans);
    return 0;
}
